diff --git a/ChangeLog.d/feature/ZBXNEXT-2289 b/ChangeLog.d/feature/ZBXNEXT-2289
new file mode 100644
index 00000000000..e78084f8714
--- /dev/null
+++ b/ChangeLog.d/feature/ZBXNEXT-2289
@@ -0,0 +1 @@
+A.F.I..... [ZBXNEXT-2289] implemented multiple LDAP sources for user authentication (gcalenko, vmurzins)
diff --git a/create/src/schema.tmpl b/create/src/schema.tmpl
index ef300d065fa..a9c7bae8753 100644
--- a/create/src/schema.tmpl
+++ b/create/src/schema.tmpl
@@ -341,7 +341,9 @@ FIELD		|name		|t_varchar(64)	|''	|NOT NULL	|0
 FIELD		|gui_access	|t_integer	|'0'	|NOT NULL	|0
 FIELD		|users_status	|t_integer	|'0'	|NOT NULL	|0
 FIELD		|debug_mode	|t_integer	|'0'	|NOT NULL	|0
+FIELD		|userdirectoryid	|t_id	|NULL	|NULL	|0 |2|userdirectory	|	|RESTRICT
 UNIQUE		|1		|name
+INDEX		|2	|userdirectoryid
 
 TABLE|users_groups|id|ZBX_DATA
 FIELD		|id		|t_id		|	|NOT NULL	|0
@@ -483,12 +485,6 @@ FIELD		|work_period	|t_varchar(255)	|'1-5,09:00-18:00'|NOT NULL|0
 FIELD		|alert_usrgrpid	|t_id		|	|NULL		|0			|1|usrgrp	|usrgrpid	|RESTRICT
 FIELD		|default_theme	|t_varchar(128)	|'blue-theme'|NOT NULL	|ZBX_NODATA
 FIELD		|authentication_type|t_integer	|'0'	|NOT NULL	|ZBX_NODATA
-FIELD		|ldap_host	|t_varchar(255)	|''	|NOT NULL	|ZBX_NODATA
-FIELD		|ldap_port	|t_integer	|389	|NOT NULL	|ZBX_NODATA
-FIELD		|ldap_base_dn	|t_varchar(255)	|''	|NOT NULL	|ZBX_NODATA
-FIELD		|ldap_bind_dn	|t_varchar(255)	|''	|NOT NULL	|ZBX_NODATA
-FIELD		|ldap_bind_password|t_varchar(128)|''	|NOT NULL	|ZBX_NODATA
-FIELD		|ldap_search_attribute|t_varchar(128)|''|NOT NULL	|ZBX_NODATA
 FIELD		|discovery_groupid|t_id		|	|NOT NULL	|ZBX_PROXY		|2|hstgrp	|groupid	|RESTRICT
 FIELD		|max_in_table	|t_integer	|'50'	|NOT NULL	|ZBX_NODATA
 FIELD		|search_limit	|t_integer	|'1000'	|NOT NULL	|ZBX_NODATA
@@ -593,8 +589,10 @@ FIELD		|geomaps_tile_provider|t_varchar(255)	|''	|NOT NULL	|0
 FIELD		|geomaps_tile_url	|t_varchar(1024)|''	|NOT NULL	|ZBX_NODATA
 FIELD		|geomaps_max_zoom	|t_integer	|'0'	|NOT NULL	|ZBX_NODATA
 FIELD		|geomaps_attribution|t_varchar(1024)|''	|NOT NULL	|ZBX_NODATA
+FIELD		|ldap_userdirectoryid	|t_id	|NULL |NULL	|0		|3|userdirectory	|userdirectoryid|RESTRICT
 INDEX		|1		|alert_usrgrpid
 INDEX		|2		|discovery_groupid
+INDEX		|3		|ldap_userdirectoryid
 
 TABLE|triggers|triggerid|ZBX_TEMPLATE
 FIELD		|triggerid	|t_id		|	|NOT NULL	|0
@@ -1932,8 +1930,21 @@ FIELD		|operator		|t_integer	|'0'	|NOT NULL	|0
 FIELD		|value			|t_varchar(255)	|''	|NOT NULL	|0
 INDEX		|1			|slaid
 
+TABLE|userdirectory|userdirectoryid
+FIELD		|userdirectoryid	|t_id			|		|NOT NULL	|0
+FIELD		|name				|t_varchar(128)	|''		|NOT NULL	|0
+FIELD		|description		|t_shorttext	|''		|NOT NULL	|0
+FIELD		|host				|t_varchar(255)	|''		|NOT NULL	|0
+FIELD		|port				|t_integer		|'389'	|NOT NULL	|0
+FIELD		|base_dn			|t_varchar(255)	|''		|NOT NULL	|0
+FIELD		|bind_dn			|t_varchar(255)	|''		|NOT NULL	|0
+FIELD		|bind_password		|t_varchar(128)	|''		|NOT NULL	|0
+FIELD		|search_attribute	|t_varchar(128)	|''		|NOT NULL	|0
+FIELD		|start_tls			|t_integer		|'0'	|NOT NULL	|0
+FIELD		|search_filter		|t_varchar(255)	|''		|NOT NULL	|0
+
 TABLE|dbversion|dbversionid|
 FIELD		|dbversionid	|t_id		|	|NOT NULL	|0
 FIELD		|mandatory	|t_integer	|'0'	|NOT NULL	|
 FIELD		|optional	|t_integer	|'0'	|NOT NULL	|
-ROW		|1		|6000000	|6000000
+ROW		|1		|6000015	|6000015
diff --git a/src/libs/zbxdbupgrade/dbupgrade_6000.c b/src/libs/zbxdbupgrade/dbupgrade_6000.c
index 02e39f9687b..5b55293e110 100644
--- a/src/libs/zbxdbupgrade/dbupgrade_6000.c
+++ b/src/libs/zbxdbupgrade/dbupgrade_6000.c
@@ -18,6 +18,7 @@
 **/
 
 #include "common.h"
+#include "db.h"
 #include "dbupgrade.h"
 
 extern unsigned char	program_type;
@@ -33,6 +34,146 @@ static int	DBpatch_6000000(void)
 	return SUCCEED;
 }
 
+static int	DBpatch_6000001(void)
+{
+	const ZBX_TABLE	table =
+		{"userdirectory", "userdirectoryid", 0,
+			{
+				{"userdirectoryid", NULL, NULL, NULL, 0, ZBX_TYPE_ID, ZBX_NOTNULL, 0},
+				{"name", "", NULL, NULL, 128, ZBX_TYPE_CHAR, ZBX_NOTNULL, 0},
+				{"description", "", NULL, NULL, 255, ZBX_TYPE_SHORTTEXT, ZBX_NOTNULL, 0},
+				{"host", "", NULL, NULL, 255, ZBX_TYPE_CHAR, ZBX_NOTNULL, 0},
+				{"port", "389", NULL, NULL, 0, ZBX_TYPE_INT, ZBX_NOTNULL, 0},
+				{"base_dn", "", NULL, NULL, 255, ZBX_TYPE_CHAR, ZBX_NOTNULL, 0},
+				{"bind_dn", "", NULL, NULL, 255, ZBX_TYPE_CHAR, ZBX_NOTNULL, 0},
+				{"bind_password", "", NULL, NULL, 128, ZBX_TYPE_CHAR, ZBX_NOTNULL, 0},
+				{"search_attribute", "", NULL, NULL, 128, ZBX_TYPE_CHAR, ZBX_NOTNULL, 0},
+				{"start_tls", "0", NULL, NULL, 0, ZBX_TYPE_INT, ZBX_NOTNULL, 0},
+				{"search_filter", "", NULL, NULL, 255, ZBX_TYPE_CHAR, ZBX_NOTNULL, 0},
+				{0}
+			},
+			NULL
+		};
+
+	return DBcreate_table(&table);
+}
+
+static int	DBpatch_6000002(void)
+{
+	const ZBX_FIELD	field = {"ldap_userdirectoryid", NULL, NULL, NULL, 0, ZBX_TYPE_ID, 0, 0};
+
+	return DBadd_field("config", &field);
+}
+
+static int	DBpatch_6000003(void)
+{
+	const ZBX_FIELD	field = {"ldap_userdirectoryid", NULL, "userdirectory", "userdirectoryid", 0, ZBX_TYPE_ID, 0, 0};
+
+	return DBadd_foreign_key("config", 3, &field);
+}
+
+static int	DBpatch_6000004(void)
+{
+	const ZBX_FIELD	field = {"userdirectoryid", NULL, NULL, NULL, 0, ZBX_TYPE_ID, 0, 0};
+
+	return DBadd_field("usrgrp", &field);
+}
+
+static int	DBpatch_6000005(void)
+{
+	int		rc = ZBX_DB_OK;
+	DB_RESULT	result;
+	DB_ROW		row;
+
+	if (NULL == (result = DBselect("select ldap_host,ldap_port,ldap_base_dn,ldap_bind_dn,"
+			"ldap_bind_password,ldap_search_attribute"
+			" from config where ldap_configured=1")))
+	{
+		return FAIL;
+	}
+
+	if (NULL != (row = DBfetch(result)))
+	{
+		char	*base_dn_esc, *bind_dn_esc, *password_esc, *search_esc;
+
+		base_dn_esc = DBdyn_escape_string(row[2]);
+		bind_dn_esc = DBdyn_escape_string(row[3]);
+		password_esc = DBdyn_escape_string(row[4]);
+		search_esc = DBdyn_escape_string(row[5]);
+
+		rc = DBexecute("insert into userdirectory (userdirectoryid,name,description,host,port,"
+				"base_dn,bind_dn,bind_password,search_attribute,start_tls) values "
+				"(1,'Default LDAP server','','%s',%s,'%s','%s','%s','%s',%d)",
+				row[0], row[1], base_dn_esc, bind_dn_esc, password_esc, search_esc, 0);
+
+		zbx_free(search_esc);
+		zbx_free(password_esc);
+		zbx_free(bind_dn_esc);
+		zbx_free(base_dn_esc);
+	}
+
+	DBfree_result(result);
+
+	if (ZBX_DB_OK > rc)
+		return FAIL;
+
+	return SUCCEED;
+}
+
+static int	DBpatch_6000006(void)
+{
+	if (ZBX_DB_OK > DBexecute("update config set ldap_userdirectoryid=1 where ldap_configured=1"))
+		return FAIL;
+
+	return SUCCEED;
+}
+
+static int	DBpatch_6000007(void)
+{
+	return DBdrop_field("config", "ldap_host");
+}
+
+static int	DBpatch_6000008(void)
+{
+	return DBdrop_field("config", "ldap_port");
+}
+
+static int	DBpatch_6000009(void)
+{
+	return DBdrop_field("config", "ldap_base_dn");
+}
+
+static int	DBpatch_6000010(void)
+{
+	return DBdrop_field("config", "ldap_bind_dn");
+}
+
+static int	DBpatch_6000011(void)
+{
+	return DBdrop_field("config", "ldap_bind_password");
+}
+
+static int	DBpatch_6000012(void)
+{
+	return DBdrop_field("config", "ldap_search_attribute");
+}
+
+static int	DBpatch_6000013(void)
+{
+	return DBcreate_index("config", "config_3", "ldap_userdirectoryid", 0);
+}
+
+static int	DBpatch_6000014(void)
+{
+	const ZBX_FIELD	field = {"userdirectoryid", NULL, "userdirectory", "userdirectoryid", 0, ZBX_TYPE_ID, 0, 0};
+
+	return DBadd_foreign_key("usrgrp", 2, &field);
+}
+
+static int	DBpatch_6000015(void)
+{
+	return DBcreate_index("usrgrp", "usrgrp_2", "userdirectoryid", 0);
+}
 #endif
 
 DBPATCH_START(6000)
@@ -40,5 +181,20 @@ DBPATCH_START(6000)
 /* version, duplicates flag, mandatory flag */
 
 DBPATCH_ADD(6000000, 0, 1)
+DBPATCH_ADD(6000001, 0, 1)
+DBPATCH_ADD(6000002, 0, 1)
+DBPATCH_ADD(6000003, 0, 1)
+DBPATCH_ADD(6000004, 0, 1)
+DBPATCH_ADD(6000005, 0, 1)
+DBPATCH_ADD(6000006, 0, 1)
+DBPATCH_ADD(6000007, 0, 1)
+DBPATCH_ADD(6000008, 0, 1)
+DBPATCH_ADD(6000009, 0, 1)
+DBPATCH_ADD(6000010, 0, 1)
+DBPATCH_ADD(6000011, 0, 1)
+DBPATCH_ADD(6000012, 0, 1)
+DBPATCH_ADD(6000013, 0, 1)
+DBPATCH_ADD(6000014, 0, 1)
+DBPATCH_ADD(6000015, 0, 1)
 
 DBPATCH_END()
diff --git a/ui/app/controllers/CControllerAuditLogList.php b/ui/app/controllers/CControllerAuditLogList.php
index f768f0a0983..6f6f19ad57b 100644
--- a/ui/app/controllers/CControllerAuditLogList.php
+++ b/ui/app/controllers/CControllerAuditLogList.php
@@ -242,6 +242,7 @@ class CControllerAuditLogList extends CController {
 			CAudit::RESOURCE_TRIGGER => _('Trigger'),
 			CAudit::RESOURCE_TRIGGER_PROTOTYPE => _('Trigger prototype'),
 			CAudit::RESOURCE_USER => _('User'),
+			CAudit::RESOURCE_USERDIRECTORY => _('User directory'),
 			CAudit::RESOURCE_USER_GROUP => _('User group'),
 			CAudit::RESOURCE_USER_ROLE => _('User role'),
 			CAudit::RESOURCE_VALUE_MAP => _('Value map')
diff --git a/ui/app/controllers/CControllerAuthenticationEdit.php b/ui/app/controllers/CControllerAuthenticationEdit.php
index e4b6d51d1c5..6e501cf0604 100644
--- a/ui/app/controllers/CControllerAuthenticationEdit.php
+++ b/ui/app/controllers/CControllerAuthenticationEdit.php
@@ -32,41 +32,36 @@ class CControllerAuthenticationEdit extends CController {
 	 */
 	protected function checkInput() {
 		$fields = [
-			'form_refresh' =>				'string',
-			'ldap_test_user' =>				'string',
-			'ldap_test_password' =>			'string',
-			'change_bind_password' =>		'in 0,1',
-			'db_authentication_type' =>		'string',
-			'authentication_type' =>		'in '.ZBX_AUTH_INTERNAL.','.ZBX_AUTH_LDAP,
-			'http_auth_enabled' =>			'in '.ZBX_AUTH_HTTP_DISABLED.','.ZBX_AUTH_HTTP_ENABLED,
-			'http_login_form' =>			'in '.ZBX_AUTH_FORM_ZABBIX.','.ZBX_AUTH_FORM_HTTP,
-			'http_strip_domains' =>			'db config.http_strip_domains',
-			'http_case_sensitive' =>		'in '.ZBX_AUTH_CASE_INSENSITIVE.','.ZBX_AUTH_CASE_SENSITIVE,
-			'ldap_case_sensitive' =>		'in '.ZBX_AUTH_CASE_INSENSITIVE.','.ZBX_AUTH_CASE_SENSITIVE,
-			'ldap_configured' =>			'in '.ZBX_AUTH_LDAP_DISABLED.','.ZBX_AUTH_LDAP_ENABLED,
-			'ldap_host' =>					'db config.ldap_host',
-			'ldap_port' =>					'int32',
-			'ldap_base_dn' =>				'db config.ldap_base_dn',
-			'ldap_bind_dn' =>				'db config.ldap_bind_dn',
-			'ldap_search_attribute' =>		'db config.ldap_search_attribute',
-			'ldap_bind_password' =>			'db config.ldap_bind_password',
-			'saml_auth_enabled' =>			'in '.ZBX_AUTH_SAML_DISABLED.','.ZBX_AUTH_SAML_ENABLED,
-			'saml_idp_entityid' =>			'db config.saml_idp_entityid',
-			'saml_sso_url' =>				'db config.saml_sso_url',
-			'saml_slo_url' =>				'db config.saml_slo_url',
-			'saml_username_attribute' =>	'db config.saml_username_attribute',
-			'saml_sp_entityid' =>			'db config.saml_sp_entityid',
-			'saml_nameid_format' =>			'db config.saml_nameid_format',
-			'saml_sign_messages' =>			'in 0,1',
-			'saml_sign_assertions' =>		'in 0,1',
-			'saml_sign_authn_requests' =>	'in 0,1',
-			'saml_sign_logout_requests' =>	'in 0,1',
-			'saml_sign_logout_responses' =>	'in 0,1',
-			'saml_encrypt_nameid' =>		'in 0,1',
-			'saml_encrypt_assertions' =>	'in 0,1',
-			'saml_case_sensitive' =>		'in '.ZBX_AUTH_CASE_INSENSITIVE.','.ZBX_AUTH_CASE_SENSITIVE,
-			'passwd_min_length' =>			'int32',
-			'passwd_check_rules' =>			'int32|ge 0|le '.(PASSWD_CHECK_CASE | PASSWD_CHECK_DIGITS | PASSWD_CHECK_SPECIAL | PASSWD_CHECK_SIMPLE)
+			'form_refresh' =>					'string',
+			'change_bind_password' =>			'in 0,1',
+			'db_authentication_type' =>			'string',
+			'authentication_type' =>			'in '.ZBX_AUTH_INTERNAL.','.ZBX_AUTH_LDAP,
+			'http_auth_enabled' =>				'in '.ZBX_AUTH_HTTP_DISABLED.','.ZBX_AUTH_HTTP_ENABLED,
+			'http_login_form' =>				'in '.ZBX_AUTH_FORM_ZABBIX.','.ZBX_AUTH_FORM_HTTP,
+			'http_strip_domains' =>				'db config.http_strip_domains',
+			'http_case_sensitive' =>			'in '.ZBX_AUTH_CASE_INSENSITIVE.','.ZBX_AUTH_CASE_SENSITIVE,
+			'ldap_configured' =>				'in '.ZBX_AUTH_LDAP_DISABLED.','.ZBX_AUTH_LDAP_ENABLED,
+			'ldap_servers' =>					'array',
+			'ldap_default_row_index' =>			'int32',
+			'ldap_case_sensitive' =>			'in '.ZBX_AUTH_CASE_INSENSITIVE.','.ZBX_AUTH_CASE_SENSITIVE,
+			'ldap_removed_userdirectoryids' =>	'array',
+			'saml_auth_enabled' =>				'in '.ZBX_AUTH_SAML_DISABLED.','.ZBX_AUTH_SAML_ENABLED,
+			'saml_idp_entityid' =>				'db config.saml_idp_entityid',
+			'saml_sso_url' =>					'db config.saml_sso_url',
+			'saml_slo_url' =>					'db config.saml_slo_url',
+			'saml_username_attribute' =>		'db config.saml_username_attribute',
+			'saml_sp_entityid' =>				'db config.saml_sp_entityid',
+			'saml_nameid_format' =>				'db config.saml_nameid_format',
+			'saml_sign_messages' =>				'in 0,1',
+			'saml_sign_assertions' =>			'in 0,1',
+			'saml_sign_authn_requests' =>		'in 0,1',
+			'saml_sign_logout_requests' =>		'in 0,1',
+			'saml_sign_logout_responses' =>		'in 0,1',
+			'saml_encrypt_nameid' =>			'in 0,1',
+			'saml_encrypt_assertions' =>		'in 0,1',
+			'saml_case_sensitive' =>			'in '.ZBX_AUTH_CASE_INSENSITIVE.','.ZBX_AUTH_CASE_SENSITIVE,
+			'passwd_min_length' =>				'int32',
+			'passwd_check_rules' =>				'int32|ge 0|le '.(PASSWD_CHECK_CASE | PASSWD_CHECK_DIGITS | PASSWD_CHECK_SPECIAL | PASSWD_CHECK_SIMPLE)
 		];
 
 		$ret = $this->validateInput($fields);
@@ -95,8 +90,6 @@ class CControllerAuthenticationEdit extends CController {
 			'action_submit' => 'authentication.update',
 			'action_passw_change' => 'authentication.edit',
 			'ldap_error' => ($ldap_status['result'] == CFrontendSetup::CHECK_OK) ? '' : $ldap_status['error'],
-			'ldap_test_password' => '',
-			'ldap_test_user' => CWebUser::$data['username'],
 			'saml_error' => ($openssl_status['result'] == CFrontendSetup::CHECK_OK) ? '' : $openssl_status['error'],
 			'change_bind_password' => 0,
 			'form_refresh' => 0
@@ -108,14 +101,9 @@ class CControllerAuthenticationEdit extends CController {
 			CAuthenticationHelper::HTTP_LOGIN_FORM,
 			CAuthenticationHelper::HTTP_STRIP_DOMAINS,
 			CAuthenticationHelper::HTTP_CASE_SENSITIVE,
-			CAuthenticationHelper::LDAP_CASE_SENSITIVE,
 			CAuthenticationHelper::LDAP_CONFIGURED,
-			CAuthenticationHelper::LDAP_HOST,
-			CAuthenticationHelper::LDAP_PORT,
-			CAuthenticationHelper::LDAP_BASE_DN,
-			CAuthenticationHelper::LDAP_BIND_DN,
-			CAuthenticationHelper::LDAP_SEARCH_ATTRIBUTE,
-			CAuthenticationHelper::LDAP_BIND_PASSWORD,
+			CAuthenticationHelper::LDAP_USERDIRECTORYID,
+			CAuthenticationHelper::LDAP_CASE_SENSITIVE,
 			CAuthenticationHelper::SAML_AUTH_ENABLED,
 			CAuthenticationHelper::SAML_IDP_ENTITYID,
 			CAuthenticationHelper::SAML_SSO_URL,
@@ -140,26 +128,16 @@ class CControllerAuthenticationEdit extends CController {
 		}
 
 		if ($this->hasInput('form_refresh')) {
-			$data['ldap_bind_password'] = '';
 			$this->getInputs($data, [
 				'form_refresh',
 				'change_bind_password',
-				'db_authentication_type',
 				'authentication_type',
 				'http_auth_enabled',
 				'http_login_form',
 				'http_strip_domains',
 				'http_case_sensitive',
-				'ldap_case_sensitive',
 				'ldap_configured',
-				'ldap_host',
-				'ldap_port',
-				'ldap_base_dn',
-				'ldap_bind_dn',
-				'ldap_search_attribute',
-				'ldap_bind_password',
-				'ldap_test_user',
-				'ldap_test_password',
+				'ldap_case_sensitive',
 				'saml_auth_enabled',
 				'saml_idp_entityid',
 				'saml_sso_url',
@@ -179,21 +157,64 @@ class CControllerAuthenticationEdit extends CController {
 				'passwd_check_rules'
 			]);
 
+			$data['ldap_servers'] = $this->getLdapServerUserGroupCount($this->getInput('ldap_servers', []));
+			$data['ldap_default_row_index'] = $this->getInput('ldap_default_row_index', 0);
+			$data['ldap_removed_userdirectoryids'] = $this->getInput('ldap_removed_userdirectoryids', []);
+
 			$data += $auth;
 		}
 		else {
 			$data += $auth;
-			$data['db_authentication_type'] = $data['authentication_type'];
-			$data['change_bind_password'] = ($data['ldap_bind_password'] === '') ? 1 : 0;
+
+			$data['ldap_servers'] = API::UserDirectory()->get([
+				'output' => ['userdirectoryid', 'name', 'description', 'host', 'port', 'base_dn', 'search_attribute',
+					'search_filter', 'start_tls', 'bind_dn'
+				],
+				'selectUsrgrps' => API_OUTPUT_COUNT,
+				'sortfield' => ['name'],
+				'sortorder' => ZBX_SORT_UP
+			]);
+
+			$data['ldap_default_row_index'] = array_search($data[CAuthenticationHelper::LDAP_USERDIRECTORYID],
+				array_column($data['ldap_servers'], 'userdirectoryid')
+			);
+			$data['ldap_removed_userdirectoryids'] = [];
 		}
 
+		unset($data[CAuthenticationHelper::LDAP_USERDIRECTORYID]);
 		$data['ldap_enabled'] = ($ldap_status['result'] == CFrontendSetup::CHECK_OK
 				&& $data['ldap_configured'] == ZBX_AUTH_LDAP_ENABLED);
 		$data['saml_enabled'] = ($openssl_status['result'] == CFrontendSetup::CHECK_OK
 				&& $data['saml_auth_enabled'] == ZBX_AUTH_SAML_ENABLED);
+		$data['db_authentication_type'] = CAuthenticationHelper::get(CAuthenticationHelper::AUTHENTICATION_TYPE);
 
 		$response = new CControllerResponseData($data);
 		$response->setTitle(_('Configuration of authentication'));
 		$this->setResponse($response);
 	}
+
+	private function getLdapServerUserGroupCount(array $ldap_servers): array {
+		$ldap_serverids = array_column($ldap_servers, 'userdirectoryid');
+
+		$db_ldap_servers = $ldap_serverids
+			? API::UserDirectory()->get([
+				'output' => ['userdirectoryid'],
+				'selectUsrgrps' => API_OUTPUT_COUNT,
+				'userdirectoryids' => $ldap_serverids,
+				'preservekeys' => true
+			])
+			: [];
+
+		foreach ($ldap_servers as &$ldap_server) {
+			$ldap_server['usrgrps'] = 0;
+
+			if (array_key_exists('userdirectoryid', $ldap_server)
+					&& array_key_exists($ldap_server['userdirectoryid'], $db_ldap_servers)) {
+				$ldap_server['usrgrps'] = $db_ldap_servers[$ldap_server['userdirectoryid']]['usrgrps'];
+			}
+		}
+		unset($ldap_server);
+
+		return $ldap_servers;
+	}
 }
